/// <reference types="react" />
import * as React from 'react';
import Cropper from './Cropper';
export interface CropViewerState {
    previewImage?: File;
    selectedImage?: string;
}
export interface CropProps {
    prefixCls: string;
    value: Blob;
    onChange: (blob: Blob) => void;
    size?: Array<number>;
    circle?: boolean;
    renderModal: (args?: any) => React.ComponentElement<any, any>;
    getSpinContent: () => React.ComponentElement<any, any>;
    locale?: String;
    accept?: String;
    thumbnailSizes?: Array<Array<number>>;
    showSelected: boolean;
    resetPreviewAfterSelectImage: boolean;
}
export default class CropViewer extends React.Component<CropProps, CropViewerState> {
    static Cropper: typeof Cropper;
    static defaultProps: {
        prefixCls: string;
        size: number[];
        circle: boolean;
        locale: string;
        accept: null;
        showSelected: boolean;
        resetPreviewAfterSelectImage: boolean;
    };
    private selectImageCallback;
    private cancelSelectImageCallback;
    constructor(props: any);
    componentWillReceiveProps(nextProps: any): void;
    loadSelectedImage: (blobOrString: string | Blob) => void;
    readBlob: (blob: Blob) => void;
    reset: () => void;
    selectImage: (file: any) => Promise<{}>;
    onChange: (fileblob: Blob) => void;
    render(): JSX.Element;
}
