/// <reference types="react" />
import * as React from 'react';
export declare type imageAttr = 'width' | 'height';
export interface ImageState {
    width: number;
    height: number;
    left: number;
    top: number;
    [x: string]: number;
}
export interface DialogProps {
    title: any;
    defaultProps: any;
    footer: any;
    visible: boolean;
    width: number;
    onCancel: (args?: any) => any;
    onOk?: (args?: any) => any;
}
export interface CropperProps {
    file: File;
    size: Array<number>;
    onChange: (args: any) => void;
    prefixCls?: string;
    circle?: boolean;
    spin?: React.ComponentElement<any, any>;
    renderModal?: (args?: any) => React.ComponentElement<DialogProps, any>;
    locale?: String;
    thumbnailSizes: Array<Array<number>>;
}
export default class Cropper extends React.Component<CropperProps, any> {
    static defaultProps: {
        prefixCls: string;
        size: number[];
        circle: boolean;
        onChange: () => void;
        locale: string;
    };
    refs: {
        viewport: HTMLElement;
        dragger: HTMLElement;
        dragNotice: HTMLElement;
        Canvas2x: HTMLCanvasElement;
        Canvas1x: HTMLCanvasElement;
    };
    updateThumbnail: () => void;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    readFile: (file: File) => void;
    loadImage: (reader: FileReader) => void;
    scaleImage: (scale: any) => void;
    applyImageState: (imageState: any) => void;
    normalizeImage: (image: any) => void;
    applyPositions: () => void;
    onMouseDown: () => void;
    dragStart: (ev: any) => void;
    dragOver: (ev: any) => void;
    dragEnd: () => void;
    handleCancel: () => void;
    handleOk: () => void;
    hideModal: () => void;
    getThumbnailSize: (index: any) => number[];
    render(): JSX.Element;
}
