'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

;
;

var Uploader = function (_React$Component) {
    _inherits(Uploader, _React$Component);

    function Uploader() {
        _classCallCheck(this, Uploader);

        var _this = _possibleConstructorReturn(this, _React$Component.apply(this, arguments));

        _this.onClick = function (ev) {
            var el = _this.refs.file;
            if (!el) {
                return;
            }
            el.click();
        };
        _this.selectFile = function (ev) {
            var file = _this.refs.file.files[0];
            if (/image\/*/g.test(file.type)) {
                _this.props.onSelectImage(file);
            }
        };
        return _this;
    }

    Uploader.prototype.render = function render() {
        var _props = this.props,
            prefixCls = _props.prefixCls,
            accept = _props.accept;

        return React.createElement("span", { className: prefixCls + '-btn ' + prefixCls + '-btn-ghost', type: "ghost", onClick: this.onClick }, React.createElement("input", { type: "file", ref: "file", accept: accept, style: { display: 'none' }, onChange: this.selectFile }), this.props.children || React.createElement("span", null, React.createElement(_Icon2["default"], { type: "upload" }), " Click to Upload "));
    };

    return Uploader;
}(React.Component);

exports["default"] = Uploader;
module.exports = exports['default'];